package io.hmit.modules.serviceOrder.controller;

import io.hmit.common.annotation.LogOperation;
import io.hmit.common.constant.Constant;
import io.hmit.common.page.PageData;
import io.hmit.common.utils.ExcelUtils;
import io.hmit.common.utils.Result;
import io.hmit.common.validator.AssertUtils;
import io.hmit.common.validator.ValidatorUtils;
import io.hmit.common.validator.group.AddGroup;
import io.hmit.common.validator.group.DefaultGroup;
import io.hmit.common.validator.group.UpdateGroup;
import io.hmit.modules.serviceOrder.dto.NewsDTO;
import io.hmit.modules.serviceOrder.dto.NewsDocumentDTO;
import io.hmit.modules.serviceOrder.dto.PensionServiceDocumentDTO;
import io.hmit.modules.serviceOrder.excel.NewsExcel;
import io.hmit.modules.serviceOrder.service.NewsDocumentService;
import io.hmit.modules.serviceOrder.service.NewsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 新闻管理
 *
 * @author zsh 408538940@qq.com
 * @since 1.0.0 2021-01-26
 */
@RestController
@RequestMapping("serviceOrder/news")
@Api(tags="新闻管理")
public class NewsController {
    @Autowired
    private NewsService newsService;
    @Autowired
    private NewsDocumentService newsDocumentService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    @RequiresPermissions("serviceOrder:news:page")
    public Result<PageData<NewsDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<NewsDTO> page = newsService.page(params);

        return new Result<PageData<NewsDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("serviceOrder:news:info")
    public Result<NewsDTO> get(@PathVariable("id") Long id){
        NewsDTO data = newsService.get(id);
        //获取活动新闻的附件
        Map<String,Object> param = new HashMap<>();
        param.put("newsId",data.getId());
        List<NewsDocumentDTO> newsDocumentDTOList = newsDocumentService.list(param);
        data.setNewsDocumentDTOList(newsDocumentDTOList);
        return new Result<NewsDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("serviceOrder:news:save")
    public Result save(@RequestBody NewsDTO dto){
        //校验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        newsService.save(dto);
        //保存新闻详情页面的附件
        List<NewsDocumentDTO> newsDocumentDTOList = dto.getNewsDocumentDTOList();
        if(newsDocumentDTOList!=null){
            for (NewsDocumentDTO newsDocumentDTO : newsDocumentDTOList) {
                newsDocumentDTO.setNewId(dto.getId());
                newsDocumentService.save(newsDocumentDTO);
            }
        }

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("serviceOrder:news:update")
    public Result update(@RequestBody NewsDTO dto){
        //校验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        newsService.update(dto);
        newsDocumentService.deletebyNewsId(dto.getId());

        //保存新闻详情页面的附件
        List<NewsDocumentDTO> newsDocumentDTOList = dto.getNewsDocumentDTOList();
        if(newsDocumentDTOList!=null){
            for (NewsDocumentDTO newsDocumentDTO : newsDocumentDTOList) {
                newsDocumentDTO.setNewId(dto.getId());
                newsDocumentService.save(newsDocumentDTO);
            }
        }

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("serviceOrder:news:delete")
    public Result delete(@RequestBody Long[] ids){
        //校验数据
        AssertUtils.isArrayEmpty(ids, "id");

        newsService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("serviceOrder:news:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<NewsDTO> list = newsService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, list, NewsExcel.class);
    }

}
